/***********************************************************/
/*                                                         */
/* main.cpp                                                */
/*                                                         */
/* usmwin project                                          */
/*                                                         */
/* scol v 4 : modified by Loc Berthelot,                  */
/*                        CryoNetworks, june 2001 :        */
/*  - the ActiveX registration is now done by usmwin       */
/*    (previously done by scol installer)                  */
/*  - in order to make it work :                           */
/*       + an "activex" keyword has been added in the      */
/*         "usm.ini" file. It points the name of           */
/*         scol-activex dll that must be used.             */
/*       + a "_GetDllVersion" function has been added to   */
/*         the scol-activex dll, in order to get the dll   */
/*         version number.                                 */
/*                                                         */
/***********************************************************/


#include<windows.h>
#include<stdio.h>
#include<direct.h>


/************************************************************/
/* scol v 4                                                 */
/*                                                          */
/* internal error codes for ActiveX registration management */
/*                                                          */
/************************************************************/

#define SCOLACTIVEX_REG_SUCCESS       0x00000000    // registration OK
#define SCOLACTIVEX_REG_UNAUTHORIZED  0x00000001    // user is not authorized to register
#define SCOLACTIVEX_REG_ERROR         0x00000002    // wheeuurk : dll not found, registration function pointer not found...

//Scol Class ID (ActiveX component ID, in registry)
#define SCOL_CLSID                    "CLSID\\7A96FF35-4937-11D1-8F2C-00609779BDA3\\Version"

// ActiveX registration function decl
typedef BOOL (WINAPI* GETDLLVERSION) (LPSTR);
static GETDLLVERSION p_GetDllVersion;


/*****************************************************************/
/* scol v 4                                                      */
/*                                                               */
/* BOOL CheckActiveXVersion (LPCSTR, LPCSTR)                     */
/*                                                               */
/* returns 0 if the version of scol-activex dll which is pointed */
/* by usm.ini is different from the one which is registered in   */
/* the Windows registry.                                         */
/* returns non-zero if they're the same.                         */
/*                                                               */
/*****************************************************************/
BOOL CheckActiveXVersion (LPCSTR DllName, LPCSTR DllPathName)
{
TCHAR axVer [256];
TCHAR regAxVer [256];
DWORD type, size;
HINSTANCE axDll;
HKEY scolKey;

    //first, get the version number from the dll pointed by usm.ini
	if ((axDll = LoadLibrary (DllName)) == NULL)
		return 0;	

	p_GetDllVersion = (GETDLLVERSION) GetProcAddress (axDll, "_GetDllVersion");

	if (!p_GetDllVersion)
	{
		FreeLibrary (axDll);
		return 0;
	}

	if (!p_GetDllVersion (axVer))
	{
		FreeLibrary (axDll);
		return 0;
	}


	//then, get the one from the registry
	if (RegOpenKeyEx (HKEY_CLASSES_ROOT, SCOL_CLSID, 0, KEY_READ, &scolKey) != ERROR_SUCCESS) 
	{
		FreeLibrary (axDll);
  		return 0;
	}

	type = REG_SZ;
	size = sizeof (regAxVer);
	if (RegQueryValueEx (scolKey, NULL, NULL, &type, (LPBYTE)regAxVer, &size) != ERROR_SUCCESS)
	{
		RegCloseKey (scolKey);
		FreeLibrary (axDll);
		return 0;
	}


	//if they're different, returns 0
	if (_strnicmp (axVer, regAxVer, strlen (axVer)))
	{
		RegCloseKey (scolKey);
    	FreeLibrary (axDll);
		return 0;
	}


	RegCloseKey (scolKey);
   	FreeLibrary (axDll);

	return 1;
}


/*****************************************************************/
/* scol v 4                                                      */
/*                                                               */
/* DWORD RegisterActiveX (LPCSTR)                                */
/*                                                               */
/* make the scol-activeX component register.                     */
/* returns SCOLACTIVEX_REG_SUCCESS if sucess.                    */
/* returns an error code if fails.                               */
/*                                                               */
/*****************************************************************/
DWORD RegisterActiveX (LPCSTR DllName)
{
  FARPROC lpDllEntryPoint;
  HINSTANCE hLib;


  hLib=LoadLibrary(DllName);

  if (!hLib)
  {
		//Error (getvar("ERROR_LOAD_DLL"),DllName);
	  	return SCOLACTIVEX_REG_ERROR;
  }

  lpDllEntryPoint=GetProcAddress(hLib,"DllRegisterServer");

  if (lpDllEntryPoint == NULL)
  {
		//Error(getvar("ERROR_REG_DLL"),DllName);
		FreeLibrary(hLib);
		return SCOLACTIVEX_REG_ERROR;
  }
     
  else if (((*lpDllEntryPoint)()) != S_OK)
  {
		FreeLibrary(hLib);
		return SCOLACTIVEX_REG_UNAUTHORIZED;
  };
 

  FreeLibrary(hLib);

  return SCOLACTIVEX_REG_SUCCESS;
}


/* rcupre la premire ligne
retourne un pointeur vers la ligne suivante ou NULL si termin ou erreur*/
char *stdGetLine(char *src,char *buf,int n)
{
  int c,i;

  while((c=(*(src++)))<32) if (c==0) return NULL;
  i=0;
  buf[i++]=c;
  while(((c=(*(src++)))>=32)&&(c)&&(i<n)) buf[i++]=c;
  if (c==0) src--;
  if (i==n) return NULL;
  buf[i]=0;
  return src;
}

/* decoupage d'une chaine en mots (retourne le nombre de mots)
 format strbuild */
int strCutting(char *comm, char **argv)
{
  int i,j,k,argc;
  
  i=0;
  j=-1;
  argc=0;

  while(comm[i])
  {
	  if (comm[i]==32)
	  {
		  if (j>=0) comm[j]=0;
		  j=-1;
		  i++;
	  }
	  else
	  {
		  if (j==-1)
		  {
			  j=i;
			  argv[argc++]=&comm[i];
		  }
		  if (comm[i]=='\\')
		  {
			  i++;
              if ((comm[i]>='0')&&(comm[i]<='9'))
			  {
				  k=comm[i]-'0';
				  i++;
				  if ((comm[i]>='0')&&(comm[i]<='9'))
				  {
					  k=k*10+comm[i]-'0';
					  i++;
					  if ((comm[i]>='0')&&(comm[i]<='9'))
					  {
						  k=k*10+comm[i]-'0';
						  i++;
					  }
				  }
				  comm[j++]=k;
			  }
			  else if (comm[i]=='n')
			  {
				  comm[j++]=10;
				  i++;
			  }
			  else if (comm[i]=='z')
			  {
				  comm[j++]=0;
				  i++;
			  }
			  else
			  {
				  comm[j++]=comm[i];
				  if (comm[i]) i++;
			  }
		  }
		  else comm[j++]=comm[i++];
	  }
  }
  if (j>=0) comm[j]=0;
  return argc;
}


typedef int (*FCM)( HANDLE this_inst, HANDLE prev_inst, LPSTR cmdline,
                    int cmdshow,int size );


char srcbuf[16384];


int LoadUsmIni(HINSTANCE this_inst, HINSTANCE prev_inst, LPSTR cmdline,int cmdshow)
{
	FILE *f;
	char *line;
  char buf[512];
  char* argv[128];
  int n;
  HMODULE hLibrary;
  FCM SCOLloadDLL;

	if (f=fopen("usm.ini","rb"))
	{
		srcbuf[fread(srcbuf,1,2047,f)]=0;
		fclose(f);
		line=srcbuf;
		while(line=stdGetLine(line,buf,512))
		{
			if (n=strCutting(buf,argv))
			{
				//register ActiveX
				if (((cmdline == NULL) || (!strcmp (cmdline, "") || (!_strnicmp (cmdline, "/install", strlen ("/install"))))) && (n>1) && (!_strnicmp (argv[0], "activex", strlen ("activex"))))
				{
					DWORD axRegCode;
					TCHAR axName [512];
					DWORD i;
	
					
					GetModuleFileName(NULL, axName, 512);
					i = (DWORD) (strlen ((char*)axName) - 1);
					while ((axName[i] != '/') && (axName[i] != '\\'))
						i--;
					axName[i+1] = '\0';
					strcat (axName, argv[1]);
	
					axRegCode = RegisterActiveX (axName);
	
					if (axRegCode == SCOLACTIVEX_REG_ERROR)
					{
						MessageBox (NULL, "AxScoll.dll error", "Scol Error", MB_OK);
						return -1;
					}
	
					if (axRegCode == SCOLACTIVEX_REG_UNAUTHORIZED)
					{
						if (!CheckActiveXVersion (argv[1], axName))
						{
							TCHAR msg[512];
							sprintf (msg, "%s\n%s\n%s", "You don't have the required access to register Scol as an ActiveX component.", 
														"Some Scol functionnality will not be available.",
														"Contact your administrator to register ActiveX library with Scol.");		
							MessageBox (NULL, msg, "Scol ActiveX Warning", 0);
						}
					}
				}
				
				//launch scol machine 
	
				if ((n>1)&&(!strcmpi(argv[0],"scol")))
				{
	
				    hLibrary=LoadLibrary(argv[1]);
					if (hLibrary)
					{
						SCOLloadDLL=(FCM)GetProcAddress(hLibrary,argv[2]);
						if (SCOLloadDLL)
						{
						return SCOLloadDLL(this_inst,prev_inst,cmdline,cmdshow,1024*1024);
						}
					}
				}
			}
		}
	}
	
	MessageBox(NULL,"Bad Installation","Scol Error",MB_OK);
	return 0;
}



int PASCAL WinMain( HINSTANCE this_inst, HINSTANCE prev_inst, LPSTR cmdline,
                    int cmdshow)
{
	int i,j;
	char buf[1024];


    
	buf[0]=0;
	GetModuleFileName(NULL,buf,1024);
	i=0;j=-1;
	while(buf[i])
	{
		if ((buf[i]=='/')||(buf[i]=='\\')) j=i+1;
		i++;
	}
	if (j>0)
	{
		buf[j]=0;
		SetCurrentDirectory(buf);
	}
	return LoadUsmIni(this_inst,prev_inst,cmdline,cmdshow);
	
}




